<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 2.4: Declarations</title>
<link href="sx5c.html" rev=precedes>
<link href="sx5e.html" rel=precedes>
<link href="sx5.html" rev=subdocument>
</head>
<body>
<H2>section 2.4: Declarations</H2>

page 40
<p>You may wonder <em>why</em> variables must be declared before use.
There are two reasons:
</p><OL><li>It makes
things somewhat
easier on the compiler;
it knows right away what kind of storage to allocate
and what code to emit to store and manipulate
each variable;
it doesn't have to try to intuit the programmer's intentions.
<li>It forces a bit of useful discipline on the programmer:
you cannot introduce variables willy-nilly;
you must think about them enough to pick appropriate types for them.
(The compiler's error messages to you,
telling you that you apparently forgot to declare a variable,
are as often helpful as they are a nuisance:
they're helpful when they tell you that you misspelled a variable,
or forgot to think about exactly how you were going to use it.)
</OL><p>Although there are a few places where
``certain declarations can be made implicitly by context'',
making use of these removes the advantages of reason
2
above,
so I recommend always declaring everything explicitly.
</p><p>Most of the time,
I recommend writing one declaration per line
(as in the ``latter form'' on page 40).
For the most part, the compiler doesn't care what order declarations are in.
You can order the declarations alphabetically,
or in the order that they're used,
or to put related declarations next to each other.
Collecting all variables of the same type together on one line 
essentially orders declarations by type,
which isn't a very useful order
(it's only slightly more useful than random order).
</p><p>If you'd rather not remember the rules for default initialization

(namely that ``external or static variables are initialized to 
zero by default'' and ``automatic variables for which there is no 
initializer have... garbage values''),
you can get in the habit of initializing everything.
It never hurts to explicitly initialize something
when it would have been implicitly initialized anyway,
but forgetting to initialize something that needs it can be the 
source of frustrating bugs.
</p><p>Don't worry about the distinction between ``external or static variables'';
we haven't seen it yet.
</p><p>One mild surprise is that <TT>const</TT> variables are <em>not</em>
``constant expressions'' as defined on page 38.
You can't say something like
<pre>	const int maxline = 1000;
	char line[maxline+1];		/* WRONG */
</pre></p><hr>
<p>
Read sequentially:
<a href="sx5c.html" rev=precedes>prev</a>
<a href="sx5e.html" rel=precedes>next</a>
<a href="sx5.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
